﻿using System;
using UnityEngine;
using System.Collections.Generic;
using System.Linq;
using System.Collections;

namespace djsoapyknuckles
{
    public class djsk_fuck_machine3Controller_free: MVRScript
    {
        #region UI VARIABLES
        protected JSONStorableBool animOn_OffTOP;
        protected JSONStorableBool animOn_OffBOTTOM;
        protected JSONStorableStringChooser selectedAttachmentTarget;
        protected JSONStorableFloat bottomRotationFloat;
        protected UIDynamicSlider bottomRotationSlider;
        protected JSONStorableString assetSyncedtoTop;
        protected JSONStorableString assetSyncedtoBottom;
        #endregion

        #region MISC VARIABLES
        private Collider[] colliderArray;
        private Transform[] children;
        private Vector3[] _connectedAnchor;
        private Vector3[] _anchor;
        private List<string> selectedAttachmentTargetList = new List<string>();
        private Atom selectedAtom;
        private GameObject go;
        private GameObject selectedAttachmentGO;
        private int initLoops = 0;
        private int maxInitLoops = 3600;
        private bool scriptInitialized = false;
        private string assetSyncedtoTop_TMP;
        private string assetSyncedtoBottom_TMP;
        private Transform ObjectRoot;
        #endregion

        

        #region OVERRIDE INIT
        public override void Init()
        {
            
            try
            {
                #region USER INTERFACE
                StartCoroutine("initDeferred");
                animOn_OffTOP = new JSONStorableBool("Top Shaft on/off", false, animOn_OffCallbackTOP);
                animOn_OffTOP.storeType = JSONStorableParam.StoreType.Full;
                CreateToggle(animOn_OffTOP, true);
                RegisterBool(animOn_OffTOP);
                

                animOn_OffBOTTOM = new JSONStorableBool("Bottom Shaft on/off", false, animOn_OffCallbackBOTTOM);
                animOn_OffBOTTOM.storeType = JSONStorableParam.StoreType.Full;
                CreateToggle(animOn_OffBOTTOM, true);
                RegisterBool(animOn_OffBOTTOM);

                selectedAttachmentTarget = new JSONStorableStringChooser("SelectedAttachment", selectedAttachmentTargetList, "None", "Select Asset");
                RegisterStringChooser(selectedAttachmentTarget);
                SyncAssetsinSceneList();
                UIDynamicPopup udp = CreatePopup(selectedAttachmentTarget, false);
                udp.popup.onOpenPopupHandlers += SyncAssetsinSceneList;
                
                UIDynamicButton udb1 = CreateButton("Sync with Top Shaft", false);
                if (udb1 != null)
                { 
                    udb1.button.onClick.AddListener(() => { DoSyncSelectedAtomToTOP("topButton"); });
                }
                UIDynamicButton udb2 = CreateButton("Sync with Bottom Shaft", false);
                if (udb2 != null)
                {
                    udb2.button.onClick.AddListener(() => { DoSyncSelectedAtomToBOTTOM("bottomButton"); });
                }
                UIDynamicButton udb3 = CreateButton("Remove from Machine", false);
                if (udb3 != null)
                {
                    udb3.button.onClick.AddListener(DoUNSyncFromMachine);
                }
                bottomRotationFloat = new JSONStorableFloat("Rotate Bottom Thruster", 0f, RotateBottomCallback, -6.0f, 6.0f, true);
                bottomRotationFloat.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(bottomRotationFloat);
                bottomRotationSlider = CreateSlider(bottomRotationFloat, false);

                assetSyncedtoTop = new JSONStorableString("assetSyncedtoTop", "none");
                assetSyncedtoTop.storeType = JSONStorableParam.StoreType.Full;
                RegisterString(assetSyncedtoTop);

                assetSyncedtoBottom = new JSONStorableString("assetSyncedtoBottom", "none");
                assetSyncedtoBottom.storeType = JSONStorableParam.StoreType.Full;
                RegisterString(assetSyncedtoBottom);
                
            }
            #endregion
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        #endregion

        #region MACHINE ACTION METHODS
        protected void DoSyncSelectedAtomToTOP(string from)
        {
            SuperController.LogMessage("from = " + from);
            SuperController.LogMessage(assetSyncedtoTop.val);
            if (from == "init")
            {
                if (assetSyncedtoTop.val == "none")
                {
                    SuperController.LogMessage("initalizing with no selectedAttachment");
                    
                }
                else if (assetSyncedtoTop.val != "none")
                {
                    
                    
                    selectedAttachmentGO = getTopAttachmentFromStorable();
                    SuperController.LogMessage("selectedAttachmentGO " + selectedAttachmentGO.ToString());
                    if (selectedAttachmentGO != null)
                    {
                        Transform s;
                        DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                        Atom b = containingAtom;
                        Transform Object2Root = getObjectRoot(b.reParentObject);
                        Atom parentAtom = selectedAttachmentGO.GetComponentInParent<Atom>();
                        GameObject go2 = Object2Root.gameObject;
                        Transform tr = GameObject.Find("attachmentPointTop").transform;
                        s = selectedAttachmentGO.transform.GetChild(1);
                        
                        //move dildo object to position attachment point
                        //var v = new Vector3(180, 0, 0); //don't need this - realigned transform on machine
                        if (s.gameObject.GetComponent<FixedJoint>()) //has fixed joint
                        {
                            DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                            s.transform.position = tr.transform.position;
                            s.transform.eulerAngles = tr.eulerAngles;
                            s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();   
                            DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                        }
                        else //doesn't have fixed joint
                        {
                            DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                            s.transform.position = tr.transform.position;
                            s.transform.eulerAngles = tr.eulerAngles;
                            s.gameObject.AddComponent<FixedJoint>();
                            s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                            s.gameObject.GetComponent<Rigidbody>().isKinematic = false;
                            DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                        }
                        
                        SuperController.LogMessage("at end of init dosynctoTop");
                    }
                }
                else
                {
                    SuperController.LogMessage("selectedAttachmentGO was apparently null");
                }
            }
            else if (from != "init")//from TOP button click
            {
                
                selectedAttachmentGO = getSelectedAttachmentGOFromAttachmentSelection();
                if (selectedAttachmentGO != null && assetSyncedtoTop.val == "none" || assetSyncedtoTop.val=="")
                    {
                    Transform s;
                    DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                   
                    Atom b = containingAtom;
                    
                    Transform Object2Root = getObjectRoot(b.reParentObject);
                    Atom parentAtom = selectedAttachmentGO.GetComponentInParent<Atom>();
                    
                    GameObject go2 = Object2Root.gameObject;
                   
                    Transform tr = GameObject.Find("attachmentPointTop").transform;

                    s = selectedAttachmentGO.transform.GetChild(1);
                    //move dildo object to position attachment point
                    //var v = new Vector3(180, 0, 0); //don't need this - realigned transform on machine
                       
                if (s.gameObject.GetComponent<FixedJoint>()) //has fixed joint
                {
                     DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                     s.transform.position = tr.transform.position;
                     s.transform.eulerAngles = tr.eulerAngles;
                     s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                     s.gameObject.GetComponent<Rigidbody>().isKinematic = false;
                     DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                    
                }
                else //doesn't have fixed joint
                {
                      DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                      s.transform.position = tr.transform.position;
                      s.transform.eulerAngles = tr.eulerAngles;
                      s.gameObject.AddComponent<FixedJoint>();
                      s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                      s.gameObject.GetComponent<Rigidbody>().isKinematic = false;
                      DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                      
                }
                DoUnSetPositionStorableStrings();    
                assetSyncedtoTop.SetVal(selectedAttachmentTarget.val);
                

                }
                else
                {
                    SuperController.LogMessage("You can't sync more than one asset to the same shaft");
                }
            }
        }

        protected void DoSyncSelectedAtomToBOTTOM(string from)
        {
            SuperController.LogMessage("from = " + from);
            SuperController.LogMessage(assetSyncedtoBottom.val);

            if (from == "init")
            {
                if (assetSyncedtoBottom.val == "none")
                {
                    SuperController.LogMessage("initalizing with no selectedAttachment");

                }
                else if (assetSyncedtoBottom.val != "none")
                {
                   
                    
                    selectedAttachmentGO = getBottomAttachmentFromStorable();
                    SuperController.LogMessage("selectedAttachmentGO " + selectedAttachmentGO.ToString());
                    if (selectedAttachmentGO != null)
                    {
                        
                        Transform s;
                        DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                        Atom b = containingAtom;  
                        Transform Object2Root = getObjectRoot(b.reParentObject);
                        Atom parentAtom = selectedAttachmentGO.GetComponentInParent<Atom>();
                        GameObject go2 = Object2Root.gameObject;
                        Transform tr = GameObject.Find("attachmentPointBottom").transform;
                        s = selectedAttachmentGO.transform.GetChild(1);
                        //move dildo object to position attachment point
                        //var v = new Vector3(180, 0, 0); //don't need this - realigned transform on machine   
                    if (s.gameObject.GetComponent<FixedJoint>()) //has fixed joint
                    {
                        DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                        s.transform.position = tr.transform.position;
                        s.transform.eulerAngles = tr.eulerAngles;
                        s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                                
                        DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                    }
                    else //doesn't have fixed joint
                    {
                        DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                        s.transform.position = tr.transform.position;
                        s.transform.eulerAngles = tr.eulerAngles;
                        s.gameObject.AddComponent<FixedJoint>();
                        s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                        s.gameObject.GetComponent<Rigidbody>().isKinematic = false;
                        DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                    }
                    
                        SuperController.LogMessage("at end of init dosynctobottom");
                    }
                }
                else
                {
                    SuperController.LogMessage("selectedAttachmentGO was apparently null");
                }
            }
            else if (from != "init") //from BOTTOM button click
            {
                
                selectedAttachmentGO = getSelectedAttachmentGOFromAttachmentSelection();
                if (selectedAttachmentGO != null && assetSyncedtoBottom.val == "none" || assetSyncedtoBottom.val == "") 
                {
                    Transform s;
                    
                    DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                    Atom b = containingAtom;
                    Transform Object2Root = getObjectRoot(b.reParentObject);
                    Atom parentAtom = selectedAttachmentGO.GetComponentInParent<Atom>();
                    GameObject go2 = Object2Root.gameObject;
                    Transform tr = GameObject.Find("attachmentPointBottom").transform;
                    s = selectedAttachmentGO.transform.GetChild(1);
                    //move dildo object to position attachment point
                    //var v = new Vector3(180, 0, 0); //don't need this - realigned transform on machine
                        if (s.gameObject.GetComponent<FixedJoint>()) //has fixed joint
                        {
                            DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                            s.transform.position = tr.transform.position;
                            s.transform.eulerAngles = tr.eulerAngles;
                            s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                            s.gameObject.GetComponent<Rigidbody>().isKinematic = false;
                            DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                            
                        }
                        else //doesn't have fixed joint
                        {
                            DoGetConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                            s.transform.position = tr.transform.position;
                            s.transform.eulerAngles = tr.eulerAngles;
                            s.gameObject.AddComponent<FixedJoint>();
                            s.GetComponent<FixedJoint>().connectedBody = tr.GetComponent<Rigidbody>();
                            s.gameObject.GetComponent<Rigidbody>().isKinematic = false;
                            DoApplyConnectedAnchorandAnchorVals(selectedAttachmentGO.transform);
                            
                        }
                    DoUnSetPositionStorableStrings();
                    assetSyncedtoBottom.SetVal(selectedAttachmentTarget.val);
                }
                else
                {
                    SuperController.LogMessage("You can't sync more than one asset to the same shaft");
                }
            }
        }
        protected void DoUNSyncFromMachine()
        {
         selectedAttachmentGO = getSelectedAttachmentGOFromAttachmentSelection();
         Transform s;
        
         selectedAtom = selectedAttachmentGO.GetComponentInParent<Atom>();
         
         
         s = selectedAttachmentGO.transform.GetChild(1);
         s.gameObject.GetComponent<Rigidbody>().isKinematic = true;
         
         s.transform.position = selectedAtom.transform.position + selectedAttachmentGO.transform.position;
         s.transform.rotation = selectedAtom.transform.rotation * selectedAttachmentGO.transform.rotation;
         DoTurnCollidersforChildrenON(selectedAttachmentGO.transform);
            if (s.gameObject.GetComponent<FixedJoint>())
            {
                s.gameObject.GetComponent<FixedJoint>().connectedBody = null;
               
            }
 
            if (assetSyncedtoTop.val == selectedAttachmentTarget.val)
            {
                assetSyncedtoTop.SetValToDefault();  
            }
            else if (assetSyncedtoBottom.val == selectedAttachmentTarget.val)
            {
                assetSyncedtoBottom.SetValToDefault();
            }
            
           
        }
        #endregion

        #region UTILITY METHODS
        protected void DoUnSetPositionStorableStrings()
        {
            if (assetSyncedtoTop.val == selectedAttachmentTarget.val)
            {
                assetSyncedtoTop.SetValToDefault();
            }
            else if (assetSyncedtoBottom.val == selectedAttachmentTarget.val)
            {
                assetSyncedtoBottom.SetValToDefault();
            }
        }
        protected void SyncAssetsinSceneList()
        {
            List<string> selectedAttachmentTargetTmp = new List<string>();
            selectedAttachmentTargetTmp.Add("None");
            foreach (string a in SuperController.singleton.GetAtomUIDs())
            {
                selectedAttachmentTargetTmp.Add(a);
            }
            selectedAttachmentTarget.choices = selectedAttachmentTargetTmp;
        }
        private Transform getObjectRoot(Transform parent)
        // Recursive function searching for a transform containing the string set in objectNameSearchString
        // It is used the first time for the initialization of the script
        {
            
            foreach (Transform child in parent)
            {
                if (child.name.Contains("djsk_") || child.name.Contains("dildo"))
                {
                    return child;
                }
                else
                {
                    Transform childSearch = getObjectRoot(child);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }

        protected void DoGetConnectedAnchorandAnchorVals(Transform t)
        {
            children = t.transform.GetComponentsInChildren<Transform>();
            _connectedAnchor = new Vector3[children.Length];
            _anchor = new Vector3[children.Length];
            for (int i = 0; i < children.Length; i++)
            {
                if (children[i].GetComponent<CharacterJoint>() != null)
                {
                    //SuperController.LogMessage(children[i].ToString());
                    _connectedAnchor[i] = children[i].GetComponent<CharacterJoint>().connectedAnchor;
                    _anchor[i] = children[i].GetComponent<CharacterJoint>().anchor;
                }
            }
        }
        protected void DoGetConnectedAnchorandAnchorValsConfigurable(Transform t)
        {
            children = t.transform.GetComponentsInChildren<Transform>();
            _connectedAnchor = new Vector3[children.Length];
            _anchor = new Vector3[children.Length];
            for (int i = 0; i < children.Length; i++)
            {
                if (children[i].GetComponent<ConfigurableJoint>() != null)
                {
                    //SuperController.LogMessage(children[i].ToString());
                    _connectedAnchor[i] = children[i].GetComponent<ConfigurableJoint>().connectedAnchor;
                    _anchor[i] = children[i].GetComponent<ConfigurableJoint>().anchor;
                }
            }
        }
        protected void DoApplyConnectedAnchorandAnchorVals(Transform t)
        {
            children = t.transform.GetComponentsInChildren<Transform>();
            for (int i = 0; i < children.Length; i++)
            {
                if (children[i].GetComponent<CharacterJoint>() != null)
                {
                    children[i].GetComponent<CharacterJoint>().connectedAnchor = _connectedAnchor[i];
                    children[i].GetComponent<CharacterJoint>().anchor = _anchor[i];
                }
            }
        }
        protected void DoApplyConnectedAnchorandAnchorValsConfigurable(Transform t)
        {
            children = t.transform.GetComponentsInChildren<Transform>();
            for (int i = 0; i < children.Length; i++)
            {
                if (children[i].GetComponent<ConfigurableJoint>() != null)
                {
                    children[i].GetComponent<ConfigurableJoint>().connectedAnchor = _connectedAnchor[i];
                    children[i].GetComponent<ConfigurableJoint>().anchor = _anchor[i];
                }
            }
        }
        protected void DoTurnCollidersforChildrenON(Transform t)
        {
            colliderArray = t.GetComponentsInChildren<Collider>();
            for (int i = 0; i < colliderArray.Length; i++)
            {
                if (colliderArray[i].GetComponent<Collider>() != null)
                {
                    colliderArray[i].GetComponent<Collider>().enabled = true;
                }
            }
        }

        protected void DoTurnCollidersforChildrenOFF(Transform t)
        {
            colliderArray = t.GetComponentsInChildren<Collider>();
            for (int i = 0; i < colliderArray.Length; i++)
            {
                if (colliderArray[i].GetComponent<Collider>() != null)
                {
                    colliderArray[i].GetComponent<Collider>().enabled = false;
                }
            }
        }
       
        #endregion

        #region CALLBACKS
 
        protected void animOn_OffCallbackTOP(bool on_off)
        {
            if (GameObject.Find("actuatorCylinderTop"))
            {
                Animator _animator = GameObject.Find("actuatorCylinderTop").GetComponentInChildren<Animator>();
                if (on_off)
                {
                    _animator.enabled = true;
                }
                else
                {
                    _animator.enabled = false;
                }
            }
        }
        protected void animOn_OffCallbackBOTTOM(bool on_off)
        {
            if (GameObject.Find("actuatorCylinderBottom"))
            {
                Animator _animator = GameObject.Find("actuatorCylinderBottom").GetComponentInChildren<Animator>();
                if (on_off)
                {
                    _animator.enabled = true;
                }
                else
                {
                    _animator.enabled = false;
                }
            }
        }
        protected void RotateBottomCallback(JSONStorableFloat r)
        {
            if (GameObject.Find("actuatorBottom"))
            {
                Transform tr = GameObject.Find("actuatorBottom").transform;
                tr.localEulerAngles = new Vector3(r.val, 0.0f, 0.0f);
            }
        }
        protected GameObject getSelectedAttachmentGOFromAttachmentSelection()
        {
            GameObject GO;
            if (selectedAttachmentTarget.val != "none")
            {
                
               
                //string str = selectedAttachmentTarget.val;
                Atom a = SuperController.singleton.GetAtomByUid(selectedAttachmentTarget.val);
                
                Transform ObjectRoot = getObjectRoot(a.reParentObject);
                
                if (ObjectRoot != null && !ObjectRoot.name.Contains("machine"))
                {
                    GO = ObjectRoot.gameObject;
                    
                    return GO;
                }
                else
                    
                GO = null;
                return GO;
            }
            GO = null;
            return GO;
        }
        protected GameObject getTopAttachmentFromStorable()
        {
            GameObject GO;
            if (assetSyncedtoTop.val != "none")
            {

                Atom a = SuperController.singleton.GetAtomByUid(assetSyncedtoTop.val);
                Transform ObjectRoot = getObjectRoot(a.reParentObject);
                
                if (ObjectRoot != null && !ObjectRoot.name.Contains("machine"))
                {
                    GO = ObjectRoot.gameObject;
                    
                    return GO;
                }
                else
                    
                GO = null;
                return GO;
            }
            GO = null;
            return GO;
        }
        protected GameObject getBottomAttachmentFromStorable()
        {
            GameObject GO;
            if (assetSyncedtoBottom.val != "none")
            {

                Atom a = SuperController.singleton.GetAtomByUid(assetSyncedtoBottom.val);
                Transform ObjectRoot = getObjectRoot(a.reParentObject);
                
                if (ObjectRoot != null && !ObjectRoot.name.Contains("machine"))
                {
                    GO = ObjectRoot.gameObject;
                    
                    return GO;
                }
                else
                    
                GO = null;
                return GO;
            }
            GO = null;
            return GO;
        }
        protected IEnumerator initDeferred()
        {
            SuperController.LogMessage("in initDefered");
            yield return new WaitForEndOfFrame();
            while (SuperController.singleton.isLoading)
            {
                //SuperController.LogMessage("is loading...");
                yield return null;
            }
            //done loading...should be able to run callback methods now
            SuperController.LogMessage("we're done loading now...");
            animOn_OffCallbackTOP(animOn_OffTOP.val);
            animOn_OffCallbackBOTTOM(animOn_OffBOTTOM.val);
            RotateBottomCallback(bottomRotationFloat);
            DoSyncSelectedAtomToTOP("init");
            DoSyncSelectedAtomToBOTTOM("init");
            SuperController.LogMessage("out of init-Defered");
        }
        #endregion
    }
}
